/**
 * @file FootyLineEmpSearch.cpp
 * @brief Footy̋\邽߂̏ł
 * @author Shinji Watanabe
 * @date Oct.30.2008
 */

#include "FootyLine.h"
#include "StaticStack.h"

#define MATCH_STR(s,n)	(pNowWord->IsNonCsWord() ? IsMatched(s,pNowLower,n) : IsMatched(s,pNowChar,n))

//-----------------------------------------------------------------------------
/**
 * @brief \̌
 * @param pBeforeBetween O̍s̎zF
 * @param plsWords \񃊃Xg
 * @return ύXɕωꍇtrueԂ
 */
bool CFootyLine::SearchEmphasis(TakeOver *pBeforeBetween, LsWords *plsWords)
{
	if (!plsWords)return false;
	// 錾
	WordPt pNowWord;								//!< ݑ̋\
	TakeOver::iterator pNowBefore;					//!< Of[^Zbgp
	const wchar_t *pNowChar = GetLineData();		//!< ݑ̕
	size_t nStringLen = GetLineLength();			//!< ̒
	CStaticStack<WordPt,sizeof(int)*8> cEmpStack;	//!< ݐFĂX^bN
	EmpPos stInsert;								//!< }\
	
	// 
	TakeOver vecBetweenBackup;
	vecBetweenBackup = m_vecLineBetweenAfter;
	m_vecColorInfo.clear();
	m_vecLineBetweenAfter.clear();

	// Õf[^Zbg
	if (pBeforeBetween){									// f[^݂Ƃ̂
		stInsert.m_nPosition = 0;
		stInsert.m_bIsStart = true;
		for (pNowBefore=pBeforeBetween->begin();pNowBefore!=pBeforeBetween->end();pNowBefore++){
			(*pNowBefore)->m_bDuplix = true;				// d`FbN
			stInsert.m_Color = (*pNowBefore)->GetColor();	// R}hXg
			m_vecColorInfo.push_back(stInsert);
			cEmpStack.push(*pNowBefore);
		}
	}
	
	// 
	std::wstring strLower = GetLineData();
	const wchar_t *pNowLower = strLower.c_str();
	CEmphasisWord::SetLower(&strLower[0], nStringLen);

	// Ă
	for (size_t i=0;i<nStringLen;i++,pNowChar++,pNowLower++)
	{
		bool bWordSkipped = false;
		// 𑖍Ă
		for (pNowWord=plsWords->begin();pNowWord!=plsWords->end();pNowWord++)
		{
			// ̕ł邩`FbN
			if (pNowWord->m_bDuplix)continue;						// d`FbN
			if (i != 0)
			{
				if (pNowWord->IsOnlyHead())continue;				// 擪Ɍ
				if (!pNowWord->CheckIndependence(pNowChar-1,false))	// Ɨ`FbN(O)
					continue;
			}
			if (cEmpStack.size() == 0)
			{
				if (!pNowWord->IsPermitted(0))continue;
			}
			else
			{
				if (!pNowWord->IsPermitted(cEmpStack.top()->GetLevel()))continue;
			}
			if (nStringLen - i < pNowWord->GetLen1())				// ̒͏\H
			{
				continue;
			}

			if (nStringLen - i != pNowWord->GetLen1())
			{
				if (!pNowWord->CheckIndependence
					(pNowChar+pNowWord->GetLen1(),true))			// Ɨ`FbN()
					continue;
			}
			
			// v邩`FbN
			if (!MATCH_STR(pNowWord->GetString1(),pNowWord->GetLen1()))
				continue;

			// JnR}h}
			stInsert.m_nPosition = i;
			stInsert.m_Color = pNowWord->GetColor();
			stInsert.m_bIsStart = true;
			m_vecColorInfo.push_back(stInsert);

			// CfbNXԍֈړ
			i += pNowWord->GetLen1() - 1;
			pNowChar += pNowWord->GetLen1() - 1;
			pNowLower+= pNowWord->GetLen1() - 1;
			bWordSkipped = true;

			// \ɂďꍇ
			if (pNowWord->GetType() == EMP_WORD){
				// P̎́ȀIR}h}
				stInsert.m_nPosition = i + 1;
				stInsert.m_bIsStart = false;
				m_vecColorInfo.push_back(stInsert);
			}
			else{
				// X^bNς
				pNowWord->m_bDuplix = true;
				cEmpStack.push(pNowWord);
			}
			// ̃̕[vֈړ
			goto To_NextLoop;
		}
		
		//I`FbN
		if (cEmpStack.size()){
			pNowWord = cEmpStack.top();
			// ڂ̒Pꓖ`FbN
			if ((pNowWord->GetType() == EMP_MULTI_BETWEEN || pNowWord->GetType() == EMP_LINE_BETWEEN) && 
				nStringLen - i >= pNowWord->GetLen2()){
				if (MATCH_STR(pNowWord->GetString2(),pNowWord->GetLen2())){
					// CfbNXԍֈړ
					i += pNowWord->GetLen2() - 1;
					pNowChar  += pNowWord->GetLen2() - 1;
					pNowLower += pNowWord->GetLen2() - 1;
					bWordSkipped = true;
					// IR}h}
					stInsert.m_nPosition = i + 1;
					stInsert.m_bIsStart = false;
					m_vecColorInfo.push_back(stInsert);
					// X^bNr
					pNowWord->m_bDuplix = false;
					cEmpStack.pop();
				}
			}
		}
		// ̃[v
To_NextLoop:;
		// TQ[gyÂPڂŁA\ȂƂ͂Ɉi߂Ă
		if (!bWordSkipped && IsSurrogateLead(*pNowChar)){
			pNowChar++;i++;
		}
	}
	
	// ̃xNg
	for (;cEmpStack.size();){
		if (cEmpStack.top()->GetType() == EMP_MULTI_BETWEEN)
			m_vecLineBetweenAfter.push_back(cEmpStack.top());
		cEmpStack.top()->m_bDuplix = false;
		cEmpStack.pop();
	}

	m_bEmphasisChached = true;
	return !(vecBetweenBackup == m_vecLineBetweenAfter);
}

/*-------------------------------------------------------------------
CFootyLine::IsMatched
pStr1pStr2̕nLenvĂ邩ǂ̔fłB
-------------------------------------------------------------------*/
bool CFootyLine::IsMatched(const wchar_t *pStr1,const wchar_t *pStr2,size_t nLen){
#ifdef UNDER_CE
	/*[vČ*/
	for (size_t i=0;i<nLen;i++,pStr1++,pStr2++){
		if ((*pStr1) != (*pStr2))return false;
	}
	return true;
#else	/*UNDER_CE*/
	/*錾*/
	bool bIsOddNum = (nLen & 1) == 1;
	size_t nLoopNum = nLen >> 1;
	/*[vĕ񂪈vĂ邩`FbN*/
	unsigned long* pStrLong1 = (unsigned long*)pStr1;
	unsigned long* pStrLong2 = (unsigned long*)pStr2;
	for (size_t i=0;i<nLoopNum;i++,pStrLong1++,pStrLong2++){
		if ((*pStrLong1) != (*pStrLong2))return false;
	}
	if (bIsOddNum && pStr1[nLen-1] != pStr2[nLen-1])return false;
	return true;
#endif	/*UNDER_CE*/	
}

/*[EOF]*/
